local function espio_resetWait(mo)
	mo.espio_waitframe = nil	-- the frame we use
	mo.espio_waitdirection = nil	-- direction he goes (false = left, true = right)
	mo.espio_waittics = nil	-- tics till the next frame
end

espio.WaitFrames = function(p)
	local mo = p.mo
	if not (mo and mo.valid) then return end
	if (mo.skin != "espio") then espio_resetWait(mo) return end
	
	if (mo.state == S_PLAY_NIGHTS_STAND)
		mo.sprite2 = SPR2_WAIT
	end
	if (mo.sprite2 != SPR2_WAIT) then espio_resetWait(mo) return end
	
	-- init vars
	if (mo.espio_waitframe == nil) then mo.espio_waitframe = 0 end
	if (mo.espio_waittics == nil) then mo.espio_waittics = 4 end
	if (mo.espio_waitdirection == nil) then mo.espio_waitdirection = true end
	
	-- get vars
	mo.espio_waittics = $-1
	if not (mo.espio_waittics)
		if not (mo.espio_waitframe)	-- transition handling
			mo.espio_waitframe = 3
			mo.espio_waittics = 5
		else
			mo.espio_waitframe = (mo.espio_waitdirection) and $+1 or $-1
			mo.espio_waittics = 3
			
			-- flip directions
			if (mo.espio_waitframe == 1)
			or (mo.espio_waitframe == 5)
				mo.espio_waitdirection = not $
				mo.espio_waittics = TICRATE*4/5
			end
		end
	end
	
	local frames = {5, 4, 1, 2, 3}	-- from left to right
	espio.SetFrame(mo, frames[mo.espio_waitframe] or mo.espio_waitframe)
end